SystemOrganization addCategory: #'TreeCounting-Model'!
SystemOrganization addCategory: #'TreeCounting-Tests'!

GRObject subclass: #VONode
	instanceVariableNames: 'votes numberOfAccepts numberOfDenies children color accepts denies id blank signatures voterId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeCounting-Model'!

VONode class
	instanceVariableNames: 'id'!

VONode class
	instanceVariableNames: 'id'!

!VONode class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/25/2012 07:53'!
from: aBallot
	^ self new
		votes: aBallot votes;
		blank: aBallot isBlank;
		signatures: aBallot signatures;
		voterId: aBallot voterId;
		yourself! !

!VONode class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/8/2012 14:52'!
id
	id isNil
		ifTrue: [ id := 0 ].
	^ id := id + 1! !

!VONode class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/8/2012 14:52'!
new
	^ super new id: self id.! !

!VONode class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/25/2012 08:07'!
votes: collectionOfVotes
	^ self new votes: collectionOfVotes! !

!VONode methodsFor: 'arithmetic' stamp: 'NicolasVanderAuwera 8/23/2012 14:45'!
* aNode
	| node |
	node := self class new.
	node votes: votes * aNode votes.
	^ node! !

!VONode methodsFor: 'arithmetic' stamp: 'NicolasVanderAuwera 5/16/2012 06:30'!
+ aNode
	| node |
	node := self class new.
	node votes: votes + aNode votes.
	^ node! !

!VONode methodsFor: 'arithmetic' stamp: 'NicolasVanderAuwera 5/15/2012 21:51'!
+= aNode
	votes := votes + aNode votes! !

!VONode methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 8/6/2012 07:42'!
= aNode
	^ self id = aNode id! !

!VONode methodsFor: 'arithmetic' stamp: 'NicolasVanderAuwera 8/23/2012 15:00'!
\\ aNumber
	votes := votes collect: [ :vote | vote \\ aNumber ]! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 13:05'!
accepts
	accepts isNil
		ifTrue: [ accepts := OrderedCollection new ].
	^ accepts! !

!VONode methodsFor: 'adding' stamp: 'NicolasVanderAuwera 2/6/2012 13:05'!
addAccept: aUsername
	self accepts add: aUsername! !

!VONode methodsFor: 'adding' stamp: 'NicolasVanderAuwera 2/8/2012 15:08'!
addChild: aNode
	self children add: aNode! !

!VONode methodsFor: 'adding' stamp: 'NicolasVanderAuwera 5/15/2012 21:31'!
addChildren: collection
	self children addAll: collection! !

!VONode methodsFor: 'adding' stamp: 'NicolasVanderAuwera 2/6/2012 13:06'!
addDeny: aUsername
	self denies add: aUsername! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/6/2012 09:01'!
blank: bool
	blank := bool! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/5/2012 15:06'!
children
	^ children! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/26/2012 11:29'!
children: aCollection
	children := aCollection! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/25/2012 09:28'!
color: numberOfVotes
	self isBlank
		ifTrue: [ ^ '"#fff"' ].
	color
		ifNil: [ 
			color := Dictionary new
				at: 'average' put: '#d4e300';
				at: 'accepted' put: '#00e300';
				at: 'denied' put: '#e33100';
				yourself ].
	^ '"0-' , (color at: self state) , '-' , (color at: (self validation: numberOfVotes)) , '"'! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 13:06'!
denies
	denies isNil
		ifTrue: [ denies := OrderedCollection new ].
	^ denies! !

!VONode methodsFor: 'removing' stamp: 'NicolasVanderAuwera 2/8/2012 15:09'!
eraseChildren
	children := nil! !

!VONode methodsFor: 'testing' stamp: 'NicolasVanderAuwera 2/6/2012 15:34'!
hasAccepted: aUser
	^ self accepts includes: aUser name ! !

!VONode methodsFor: 'testing' stamp: 'NicolasVanderAuwera 8/22/2012 09:53'!
hasChildren
	^ self children isEmpty not! !

!VONode methodsFor: 'testing' stamp: 'NicolasVanderAuwera 2/6/2012 15:34'!
hasDenied: aUser
	^ self denies includes: aUser name ! !

!VONode methodsFor: 'testing' stamp: 'NicolasVanderAuwera 8/25/2012 07:50'!
hasSignatures
	^ signatures notNil! !

!VONode methodsFor: 'testing' stamp: 'NicolasVanderAuwera 8/6/2012 07:42'!
hash
	^ self id hash! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/8/2012 14:50'!
id
	^ id! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/8/2012 14:50'!
id: anObject
	id := anObject! !

!VONode methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/6/2012 09:02'!
initialize
	super initialize.
	blank := false.
	children := OrderedCollection new! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/6/2012 08:54'!
isBlank
	^ blank! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 15:27'!
numberOfAccepts
	^ self accepts size! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/5/2012 15:06'!
numberOfChildren
	^ children size! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 13:06'!
numberOfDenies
	^ self denies size! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/18/2012 08:23'!
numberOfValidations
	^ self accepts size + self denies size! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 10:08'!
percentageOfAccepted
	self numberOfAccepts + self numberOfDenies = 0
		ifTrue: [ ^ 0 ].
	^ (self numberOfAccepts / (self numberOfAccepts + self numberOfDenies) * 100) asFloat! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 10:08'!
percentageOfVoters: number
	^ (self numberOfValidations / number * 100) asFloat! !

!VONode methodsFor: 'cryptography' stamp: 'NicolasVanderAuwera 1/27/2012 08:17'!
randomNumber
	^ SecureRandom new nextFrom: 1 to: 100 ! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/9/2012 13:33'!
ratio
	self numberOfAccepts isZero
		ifTrue: [ ^ self numberOfAccepts ].
	self numberOfDenies isZero
		ifTrue: [ ^ self numberOfDenies ].
	^ self numberOfAccepts / self numberOfDenies! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:58'!
signatures
	^ signatures! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:58'!
signatures: aList
	signatures := aList! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:49'!
state
	self percentageOfAccepted <= 30
		ifTrue: [ ^ 'denied' ].
	self percentageOfAccepted >= 70
		ifTrue: [ ^ 'accepted' ].
	^ 'average'! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/18/2012 08:45'!
validation: number
	(self percentageOfVoters: number) <= 30
		ifTrue: [ ^ 'denied' ].
	(self percentageOfVoters: number) >= 70
		ifTrue: [ ^ 'accepted' ].
	^ 'average'! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/25/2012 08:05'!
voterId
	^ voterId! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/25/2012 08:05'!
voterId: anObject
	voterId := anObject! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/26/2012 11:24'!
votes
	^ votes! !

!VONode methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/26/2012 10:36'!
votes: anObject
	votes := anObject! !

Object subclass: #VOTreeCounting
	instanceVariableNames: 'levels numberOfChildren operation modulo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeCounting-Model'!

VOTreeCounting class
	instanceVariableNames: 'urn shares'!

VOTreeCounting class
	instanceVariableNames: 'urn shares'!

!VOTreeCounting class methodsFor: 'examples' stamp: 'NicolasVanderAuwera 10/31/2012 06:15'!
example
	"Example of a counting tree"

	| authority number publicBoard ballot pk ct |
	number := 20.
	urn := VOUrn new.
	publicBoard := VOCompletePublicBoard new.
	authority := VOHomomorphicAuthority new generateShares: number.
	publicBoard thresholdPublicKey: authority thresholdPublicKey.
	publicBoard paillierPrivateKey: authority paillierPrivateKey.
	shares := authority shares.
	10
		do: [ :share | 
			ballot := VOMBBallot numberOfPossibleVotes: 3.
			ballot give: 1 additionalPointsTo: 3 atRandom.
			ballot votes: (share blindArray: ballot votes with: authority thresholdPublicKey).
			urn addBallot: ballot ].
	publicBoard shares: OrderedCollection new.
	publicBoard urn: urn.
	ct := VOTreeCounting
		newFrom: (urn ballots collect: [ :b | b votes ])
		numberOfChildren: 2
		operation: #*
		modulo: authority thresholdPublicKey nsquared.
	^ ct deploy! !

!VOTreeCounting class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/25/2012 07:54'!
newFrom: ballots numberOfChildren: anInteger
	| tree previous |
	tree := self new numberOfChildren: anInteger.
	^ tree
		addLevel: (ballots collect: [ :ballot | VONode from: ballot ]) asOrderedCollection;
		deploy;
		yourself! !

!VOTreeCounting class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/25/2012 07:54'!
newFrom: ballots numberOfChildren: anInteger operation: aSymbol
	| tree |
	tree := self new numberOfChildren: anInteger.
	^ tree
		addLevel: (ballots collect: [ :ballot | VONode from: ballot votes ]) asOrderedCollection;
		operation: aSymbol;
		deploy;
		yourself! !

!VOTreeCounting class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/25/2012 07:53'!
newFrom: ballots numberOfChildren: anInteger operation: aSymbol modulo: aNumber
	| tree |
	tree := self new numberOfChildren: anInteger.
	^ tree
		addLevel: (ballots collect: [ :ballot | VONode from: ballot ]) asOrderedCollection;
		operation: aSymbol;
		modulo: aNumber;
		deploy;
		yourself! !

!VOTreeCounting class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/5/2012 13:32'!
shares
	^ shares! !

!VOTreeCounting class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/5/2012 09:48'!
urn
	^ urn! !

!VOTreeCounting methodsFor: 'adding' stamp: 'NicolasVanderAuwera 8/22/2012 10:01'!
addLevel: anOrderedCollection
	levels add: anOrderedCollection! !

!VOTreeCounting methodsFor: 'converting' stamp: 'NicolasVanderAuwera 8/21/2012 11:00'!
asJson
	| json |
	json := WriteStream on: String new.
	json nextPutAll: '{"nodes": {'.
	self nodes
		do: [ :node | 
			json
				nextPutAll: '"';
				nextPutAll: node id greaseString;
				nextPutAll: '": {},' ].
	json nextPutAll: '}, "edges": {'.
	self nodes
		do: [ :node | 
			json
				nextPutAll: '"';
				nextPutAll: node id greaseString;
				nextPutAll: '": {'.
			node children
				do: [ :child | 
					json
						nextPutAll: '"';
						nextPutAll: child id greaseString;
						nextPutAll: '": {},' ].
			json nextPutAll: '},' ].
	json nextPutAll: '}}'.
	^ json contents! !

!VOTreeCounting methodsFor: 'converting' stamp: 'NicolasVanderAuwera 8/6/2012 08:49'!
asXML
	| xml |
	xml := XMLWriter on: (WriteStream on: String new).
	xml xmlDeclaration: '1.0' encoding: 'UTF-8'.
	xml
		startTag: 'nodes';
		endTag.
	self levels
		do: [ :level | 
			level
				do: [ :node | 
					xml
						startElement: 'node' attributeList: (XMLAttribute name: 'id' value: node id greaseString);
						endTag.
					xml
						startTag: 'votes';
						endTag.
					node votes
						do: [ :vote | 
							xml
								startTag: 'vote';
								endTag.
							xml writeXmlEncoded: vote greaseString.
							xml
								startTag: '/vote';
								endTag ].
					xml
						startTag: '/votes';
						endTag.
					xml
						startTag: 'children';
						endTag.
					node children
						do: [ :child | 
							xml
								startElement: 'child' attributeList: (XMLAttribute name: 'id' value: child id greaseString);
								endTag;
								startTag: '/child';
								endTag ].
					xml
						startTag: '/children';
						endTag ].
			xml
				startTag: '/node';
				endTag ].
	xml
		startTag: '/nodes';
		endTag.
	^ xml stream contents! !

!VOTreeCounting methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/23/2012 14:45'!
createNodeFrom: previous beginAt: i
	| subNodes node result first |
	subNodes := ((i to: i + numberOfChildren - 1) collect: [ :j | previous at: j ]) asOrderedCollection.
	first := subNodes removeFirst.
	result := subNodes inject: first into: [ :r :n | (r perform: operation with: n) \\ modulo ].
	node := VONode votes: result votes.
	node
		addChild: first;
		addChildren: subNodes.
	^ node! !

!VOTreeCounting methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/16/2012 06:35'!
defaultNumberOfChildren
	^ 3! !

!VOTreeCounting methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/16/2012 06:34'!
deploy
	| level previous i size |
	levels isEmpty
		ifTrue: [ self error: 'The tree must be initialized with the last level.' ].
	[ 
	previous := levels last.
	previous size = 1 ]
		whileFalse: [ 
			level := OrderedCollection new.
			i := 1.
			[ i + numberOfChildren - 1 <= previous size ]
				whileTrue: [ 
					level add: (self createNodeFrom: previous beginAt: i).
					i := i + numberOfChildren ].
			size := previous size.
			(i to: size) do: [ :j | level add: (previous removeAt: j) ].
			levels add: level ].
	levels := levels reverse! !

!VOTreeCounting methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/22/2012 10:02'!
initialize
	super initialize.
	levels := OrderedCollection new.
	numberOfChildren := self defaultNumberOfChildren! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 10:01'!
levels
	^ levels! !

!VOTreeCounting methodsFor: 'random' stamp: 'NicolasVanderAuwera 8/25/2012 08:38'!
lowPercentageOfAccepts
	^ (self nodes select: [ :node | node percentageOfAccepted < 40 and: [ node isBlank not ] ]) atRandom! !

!VOTreeCounting methodsFor: 'random' stamp: 'NicolasVanderAuwera 8/25/2012 08:38'!
lowPercentageOfValidation
	^ (self nodes select: [ :node | (node percentageOfVoters: self numberOfVotes) < 40 and: [ node isBlank not ] ])
		atRandom! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:43'!
modulo
	^ modulo! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:43'!
modulo: anObject
	modulo := anObject! !

!VOTreeCounting methodsFor: 'search' stamp: 'NicolasVanderAuwera 8/21/2012 15:13'!
nodeWithId: anInteger
	^ self nodes detect: [ :node | node id = anInteger ]! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 10:07'!
nodes
	| nodes |
	nodes := OrderedCollection new.
	levels do: [ :level | nodes addAll: (level collect: [ :node | node ]) ].
	^ nodes! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 10:02'!
numberOfChildren
	^ numberOfChildren! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/26/2012 10:20'!
numberOfChildren: anObject
	numberOfChildren := anObject! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/6/2012 09:08'!
numberOfLeaves
	^ levels last size! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 10:20'!
numberOfVotes
	^ levels last size - (levels last select: [ :node | node isBlank ]) size! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/15/2012 20:13'!
operation: aSymbol
	operation := aSymbol! !

!VOTreeCounting methodsFor: 'random' stamp: 'NicolasVanderAuwera 8/25/2012 08:55'!
randomNode
	| random level node |
	[ 
	random := SecureRandom new.
	level := self levels at: (random nextFrom: 1 to: self levels size).
	node := level at: (random nextFrom: 1 to: level size).
	node isBlank ] whileTrue.
	^ node! !

!VOTreeCounting methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 11:35'!
root
	^ levels first first! !

TestCase subclass: #VOCountingTreeTest
	instanceVariableNames: 'treeForAddition treeForMultiplication collectionOfVotes collectionOfCiphers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeCounting-Tests'!

!VOCountingTreeTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 11:00'!
numberOfBallots
	^ 100! !

!VOCountingTreeTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/15/2012 21:22'!
numberOfChildren
	^ 2! !

!VOCountingTreeTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/15/2012 20:20'!
numberOfPossibleChoices
	^ 10! !

!VOCountingTreeTest methodsFor: 'random' stamp: 'NicolasVanderAuwera 8/20/2012 11:02'!
randomBallot
	^ (VOBallot numberOfPossibleVotes: self numberOfPossibleChoices)
		give: 1 atRandom
		additionalPointsTo: (1 to: self numberOfPossibleChoices) atRandom! !

!VOCountingTreeTest methodsFor: 'random' stamp: 'NicolasVanderAuwera 8/20/2012 11:11'!
randomCipheredBallot
	| ballot |
	ballot := VOMBBallot numberOfPossibleVotes: self numberOfPossibleChoices.
	(1 to: self numberOfPossibleChoices) do: [ :i | ballot give: (100 to: 1000) atRandom additionalPointsTo: i ].
	^ ballot! !

!VOCountingTreeTest methodsFor: 'random' stamp: 'NicolasVanderAuwera 5/15/2012 20:35'!
randomCipheredVotes
	^ (1 to: self numberOfPossibleChoices) collect: [ :i | (100 to: 1000) atRandom ]! !

!VOCountingTreeTest methodsFor: 'random' stamp: 'NicolasVanderAuwera 8/18/2012 07:55'!
randomVotes
	| votes |
	votes := (Array new: self numberOfPossibleChoices) atAllPut: 0.
	votes at: (1 to: self numberOfPossibleChoices) atRandom put: 1.
	^ votes! !

!VOCountingTreeTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/31/2012 06:15'!
setUp
	collectionOfVotes := (1 to: self numberOfBallots) collect: [ :i | self randomBallot ].
	treeForAddition := VOTreeCounting newFrom: collectionOfVotes numberOfChildren: self numberOfChildren operation: #+.
	collectionOfCiphers := (1 to: self numberOfBallots) collect: [ :i | self randomCipheredBallot ].
	treeForMultiplication := VOTreeCounting
		newFrom: collectionOfCiphers
		numberOfChildren: self numberOfChildren
		operation: #*! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/20/2012 11:14'!
testAddition
	| root |
	root := treeForAddition root.
	self assert: (collectionOfVotes sum) votes = root votes! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/21/2012 10:21'!
testAsJson
	Transcript show: treeForAddition asJson! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/22/2012 10:25'!
testChildren
	| levels |
	treeForAddition nodes do: [ :node | self assert: node numberOfChildren <= self numberOfChildren ].
	treeForMultiplication nodes do: [ :node | self assert: node numberOfChildren <= self numberOfChildren ].
	self assert: treeForAddition levels first size = 1.	"a tree must have only one root"
	self assert: treeForMultiplication levels first size = 1.
	self assert: treeForAddition levels last size = self numberOfBallots.
	self assert: treeForMultiplication levels last size = self numberOfBallots! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 10/31/2012 06:15'!
testCompleteExample
	| authority shares number urn publicBoard ballot pk ct |
	number := 20.
	urn := VOUrn new.
	publicBoard := VOCompletePublicBoard new.
	authority := VOHomomorphicAuthority new generateShares: number.
	publicBoard thresholdPublicKey: authority thresholdPublicKey.
	publicBoard paillierPrivateKey: authority paillierPrivateKey.
	shares := authority shares.
	shares
		do: [ :share | 
			ballot := VOMBBallot numberOfPossibleVotes: 3.
			ballot give: 1 additionalPointsTo: 3 atRandom.
			ballot votes: (share blindArray: ballot votes with: authority thresholdPublicKey).
			urn addBallot: ballot ].
	publicBoard shares: OrderedCollection new.
	publicBoard urn: urn.
	ct := VOTreeCounting
		newFrom: urn ballots
		numberOfChildren: 2
		operation: #*
		modulo: authority thresholdPublicKey nsquared.
	ct deploy! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/5/2012 15:25'!
testLevels
	treeForAddition levels
		do: [ :level | level do: [ :node | self assert: (node numberOfChildren > 0 and: [ node numberOfChildren <= self numberOfChildren ]) ] ]
		without: treeForAddition levels last.
	treeForAddition levels last do: [ :node | self assert: node numberOfChildren = 0 ].
	treeForMultiplication levels
		do: [ :level | level do: [ :node | self assert: (node numberOfChildren > 0 and: [ node numberOfChildren <= self numberOfChildren ]) ] ]
		without: treeForMultiplication levels last.
	treeForMultiplication levels last do: [ :node | self assert: node numberOfChildren = 0 ]! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/20/2012 11:12'!
testMultiplication
	| prod root |
	prod := collectionOfCiphers
		inject: ((Array new: self numberOfPossibleChoices) atAllPut: 1)
		into: [ :p :each | p * each votes ].
	root := treeForMultiplication root.
	self assert: prod = root votes! !

!VOCountingTreeTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/22/2012 10:23'!
testNumberOfVotes
	self assert: treeForAddition numberOfVotes = self numberOfBallots.
	self assert: treeForMultiplication numberOfVotes = self numberOfBallots! !
